/*
One of those Weeks Episode 39: Snakes and Lawyers
Copyright (c) 2008,2011 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.ep39
{
	// Adobe Imports
	import flash.display.MovieClip;
	import flash.events.Event;

	public class Snake
	extends MovieClip
	{
// ***** CONSTANTS ***********************************************************

		public static const MOVEMENT_DELAY:int = 4;

// ***** VARIABLES ***********************************************************

		public var _currentDelay:int;
		public var _targetFrame:int;
		
// ***** CONSTRUCTOR *********************************************************

		public function Snake()
		{
			addEventListener(Event.ENTER_FRAME, handleFrame);
			_currentDelay = int(Math.random() * MOVEMENT_DELAY);
			_targetFrame = totalFrames / 2;
			gotoAndStop(_targetFrame);
		}

// ***** Functions - Event handlers ******************************************

		public function handleFrame(evt:Event)
		{
			++_currentDelay;
			if (_currentDelay < MOVEMENT_DELAY)
				return;
			_currentDelay = 0;
			if (_targetFrame > currentFrame)
				gotoAndStop(currentFrame+1);
			else if (_targetFrame < currentFrame)
				gotoAndStop(currentFrame-1);
			else {
				var rnd:int = _targetFrame;
				while (rnd == _targetFrame)
					rnd = int(Math.random() * totalFrames) + 1;
				_targetFrame = rnd;
			}
		}
	} // end class
}// end package

